Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxdnd.h
===================================================================
--- /dev/null
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxdnd.h
@@ -0,0 +1,54 @@
+/*
+ * Copyright © 2008 Novell, Inc.
+ *
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Novell, Inc. not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Novell, Inc. makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * NOVELL, INC. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL NOVELL, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Author: David Reveman <davidr@novell.com>
+ */
+
+#ifndef DMXDND_H
+#define DMXDND_H
+
+#include "dmx.h"
+
+void
+dmxBEDnDRootWindowUpdate (ScreenPtr pScreen,
+			  Window    window);
+
+void
+dmxBEDnDSpriteUpdate (ScreenPtr pScreen,
+		      Window    window,
+		      int       rootX,
+		      int       rootY);
+
+Bool
+dmxScreenEventCheckDnD (ScreenPtr           pScreen,
+			xcb_generic_event_t *event);
+
+void
+dmxDnDClientMessageEvent (xEvent *event);
+
+Bool
+dmxDnDScreenInit (ScreenPtr pScreen);
+
+void
+dmxDnDScreenFini (ScreenPtr pScreen);
+
+#endif /* DMXDND_H */
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxdpms.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxdpms.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxdpms.c
@@ -56,13 +56,17 @@
 static unsigned long dpmsGeneration = 0;
 static Bool          dpmsSupported  = TRUE;
 
-static void _dmxDPMSInit(DMXScreenInfo *dmxScreen)
+/** Initialize DPMS support.  We save the current settings and turn off
+ * DPMS.  The settings are restored in #dmxDPMSTerm. */
+void dmxBEDPMSScreenInit(ScreenPtr pScreen)
 {
-    int        event_base, error_base;
-    int        major, minor;
-    CARD16     level, standby, suspend, off;
-    BOOL       state;
-    const char *monitor;
+    DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
+    int           event_base, error_base;
+    int           major, minor;
+    CARD16        level, standby, suspend, off;
+    BOOL          state;
+    const char    *monitor;
+    int           status = 1;
 
     if (dpmsGeneration != serverGeneration) {
         dpmsSupported  = TRUE;  /* On unless a backend doesn't support it */
@@ -74,37 +78,52 @@ static void _dmxDPMSInit(DMXScreenInfo *
 #endif
 
     dmxScreen->dpmsCapable = 0;
-    
+
     if (!dmxScreen->beDisplay) {
         dmxLogOutput(dmxScreen,
 		     "Cannot determine if DPMS supported (detached screen)\n");
-        dpmsSupported = FALSE;
         return;
     }
 
-    if (!DPMSQueryExtension(dmxScreen->beDisplay,
-                            &event_base, &error_base)) {
-        dmxLogOutput(dmxScreen, "DPMS not supported\n");
-        dpmsSupported = FALSE;
-        return;
-    }
-    if (!DPMSGetVersion(dmxScreen->beDisplay, &major, &minor)) {
-        dmxLogOutput(dmxScreen, "DPMS not supported\n");
-        dpmsSupported = FALSE;
+    if (dmxScreen->scrnWin != DefaultRootWindow (dmxScreen->beDisplay)) {
+        dmxLogOutput(dmxScreen,
+		     "Cannot use DPMS in window mode\n");
         return;
     }
-    if (!DPMSCapable(dmxScreen->beDisplay)) {
-        dmxLogOutput(dmxScreen, "DPMS %d.%d (not DPMS capable)\n",
-                     major, minor);
-        dpmsSupported = FALSE;
-        return;
+
+    dpmsSupported = FALSE;
+
+    XLIB_PROLOGUE (dmxScreen);
+
+    if (!(status = DPMSQueryExtension(dmxScreen->beDisplay,
+				      &event_base, &error_base)))
+	dmxLogOutput(dmxScreen, "DPMS not supported\n");
+
+    if (status)
+	if (!(status = DPMSGetVersion(dmxScreen->beDisplay, &major, &minor)))
+	    dmxLogOutput(dmxScreen, "DPMS not supported\n");
+
+    if (status)
+	if (!(status = DPMSCapable(dmxScreen->beDisplay)))
+	    dmxLogOutput(dmxScreen, "DPMS %d.%d (not DPMS capable)\n",
+			 major, minor);
+
+    if (status)
+    {
+	DPMSInfo(dmxScreen->beDisplay, &level, &state);
+	DPMSGetTimeouts(dmxScreen->beDisplay, &standby, &suspend, &off);
+	DPMSSetTimeouts(dmxScreen->beDisplay, 0, 0, 0);
+	DPMSEnable(dmxScreen->beDisplay);
+	DPMSForceLevel(dmxScreen->beDisplay, DPMSModeOn);
+
+	dpmsSupported = TRUE;
     }
 
-    DPMSInfo(dmxScreen->beDisplay, &level, &state);
-    DPMSGetTimeouts(dmxScreen->beDisplay, &standby, &suspend, &off);
-    DPMSSetTimeouts(dmxScreen->beDisplay, 0, 0, 0);
-    DPMSEnable(dmxScreen->beDisplay);
-    DPMSForceLevel(dmxScreen->beDisplay, DPMSModeOn);
+    XLIB_EPILOGUE (dmxScreen);
+
+    if (!dpmsSupported)
+	return;
+
     dmxScreen->dpmsCapable = 1;
     dmxScreen->dpmsEnabled = !!state;
     dmxScreen->dpmsStandby = standby;
@@ -125,49 +144,26 @@ static void _dmxDPMSInit(DMXScreenInfo *
                  standby, suspend, off);
 }
 
-/** Initialize DPMS support.  We save the current settings and turn off
- * DPMS.  The settings are restored in #dmxDPMSTerm. */
-void dmxDPMSInit(DMXScreenInfo *dmxScreen)
-{
-    int    interval, preferBlanking, allowExposures;
-
-                                /* Turn off DPMS */
-    _dmxDPMSInit(dmxScreen);
-
-    if (!dmxScreen->beDisplay)
-	return;
-
-                                /* Turn off screen saver */
-    XGetScreenSaver(dmxScreen->beDisplay, &dmxScreen->savedTimeout, &interval,
-		    &preferBlanking, &allowExposures);
-    XSetScreenSaver(dmxScreen->beDisplay, 0, interval,
-		    preferBlanking, allowExposures);
-    XResetScreenSaver(dmxScreen->beDisplay);
-    dmxSync(dmxScreen, FALSE);
-}
-
 /** Terminate DPMS support on \a dmxScreen.  We restore the settings
  * saved in #dmxDPMSInit. */
-void dmxDPMSTerm(DMXScreenInfo *dmxScreen)
+void dmxBEDPMSScreenFini(ScreenPtr pScreen)
 {
-    int    timeout, interval, preferBlanking, allowExposures;
+    DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
 
     if (!dmxScreen->beDisplay)
 	return;
 
-    XGetScreenSaver(dmxScreen->beDisplay, &timeout, &interval,
-		    &preferBlanking, &allowExposures);
-    XSetScreenSaver(dmxScreen->beDisplay, dmxScreen->savedTimeout, interval,
-		    preferBlanking, allowExposures);
     if (dmxScreen->dpmsCapable) {
                                 /* Restore saved state */
+	XLIB_PROLOGUE (dmxScreen);
         DPMSForceLevel(dmxScreen->beDisplay, DPMSModeOn);
         DPMSSetTimeouts(dmxScreen->beDisplay, dmxScreen->dpmsStandby,
                         dmxScreen->dpmsSuspend, dmxScreen->dpmsOff);
         if (dmxScreen->dpmsEnabled) DPMSEnable(dmxScreen->beDisplay);
         else                        DPMSDisable(dmxScreen->beDisplay);
+	XLIB_EPILOGUE (dmxScreen);
+	dmxSync(dmxScreen, FALSE);
     }
-    dmxSync(dmxScreen, FALSE);
 }
 
 /** Called when activity is detected so that DPMS power-saving mode can
@@ -203,8 +199,10 @@ int DPMSSet(ClientPtr client, int level)
 
     for (i = 0; i < dmxNumScreens; i++) {
         DMXScreenInfo *dmxScreen = &dmxScreens[i];
-	if (dmxScreen->beDisplay) {
+	if (dmxScreen->beDisplay && dmxScreen->dpmsCapable) {
+	    XLIB_PROLOGUE (dmxScreen);
 	    DPMSForceLevel(dmxScreen->beDisplay, level);
+	    XLIB_EPILOGUE (dmxScreen);
 	    dmxSync(dmxScreen, FALSE);
 	}
     }
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxdpms.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxdpms.h
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxdpms.h
@@ -36,7 +36,7 @@
 
 #ifndef _DMXDPMS_H_
 #define _DMXDPMS_H_
-extern void dmxDPMSInit(DMXScreenInfo *dmxScreen);
-extern void dmxDPMSTerm(DMXScreenInfo *dmxScreen);
+extern void dmxBEDPMSScreenInit(ScreenPtr pScreen);
+extern void dmxBEDPMSScreenFini(ScreenPtr pScreen);
 extern void dmxDPMSWakeup(void); /* Call when input is processed */
 #endif
